
const int soilMoisturePin = 1;
const int waterLevelPin = 2;
const int driverActivation = 3;

int counter = 0;
int timeToggledAt = 0;
int timeToDisableAt = -1;
bool pumpOn;

float currentSoilMoisture = 0;

void setup() {
  pinMode(driverActivation, OUTPUT);
  pinMode(waterLevelPin, INPUT);
  pinMode(soilMoisturePin, INPUT);
  Serial.begin(9600);
}

void loop() {
  if (Serial.available()== 1){
    int incoming = Serial.parseInt();
    if (incoming == 1){
      TogglePump();
    }
  }
  
  counter += 1;
  
  delay(125);

  if (timeToDisableAt == counter){
    timeToDisableAt = -1;
    digitalWrite(driverActivation, LOW);
    pumpOn = false;
  }

  //Soil Moisture Data Calculation
  for (int i = 0; i <= 100; i++) 
  { 
    currentSoilMoisture = currentSoilMoisture + analogRead(soilMoisturePin); 
    delay(1); 
  } 

  currentSoilMoisture = currentSoilMoisture/100.0; 

  //Water Level Data
  int currentWaterLevel = analogRead(waterLevelPin);

  Serial.print('&');
  Serial.print(currentSoilMoisture);
  Serial.print('@');
  Serial.print(currentWaterLevel);
  Serial.print('@');

  if (pumpOn){
    Serial.print('1');
  }
  else{
    Serial.print('0');
  }
  
  Serial.println();
  // Counter Reset
  if (counter >= 71){
    counter = 0;
  }
}

void TogglePump(){
  if (pumpOn){
    return;
  }
  digitalWrite(driverActivation, HIGH);
  timeToggledAt = counter;
  pumpOn = true;
  timeToDisableAt = timeToggledAt + 50;
  if (timeToDisableAt - 70 >= 0){
    timeToDisableAt = timeToDisableAt - 70;
  }
}
